<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    3.0 build:20120924
*/

session_start();
require_once 'qtg_init.php';
$qtg_skin='bin/css';

// INITIALISE

$ok = '';
$usr = '';
$pwd = '';
QThttpvar('ok usr pwd', 'str str str');
$pg_url='qtg_adm_login.php';
$bJava=false;

// Check install

if ( !isset($qtg_install) ) $qtg_install='';
if ( empty($qtg_install) )
{
  if ( file_exists('install/index.php') )
  {
  echo '
  <p>QuickTalk ',QTGVERSION,' <a id="exiturl" href="install/index.php">starting installation or upgrade</a>...</p>
  <script type="text/javascript">
  <!--
  setTimeout(\'window.location=document.getElementById("exiturl").href\',0);
  -->
  </script>
  ';
  exit;
  }
}

// --------
// SUBMITTED for log-in
// --------

if ( !empty($ok) )
{
  // CHECK FORM VALUE

  if ( get_magic_quotes_gpc() ) $usr = stripslashes($usr);
  if ( !QTislogin($usr,2) ) $error = $L['Username'].' '.$L['E_invalid'];
  if ( !QTispassword($pwd,2) ) $error = $L['Password'].' '.$L['E_invalid'];

  // check login
  if ( empty($error) )
  {
    if ( ($usr!=$qtg_user) && ($usr!=$qtg_user_2) ) $error=$L['E_access_denied'];
  }
  // check pwd
  if ( empty($error) )
  {
    if ( ($usr==$qtg_user) && ($pwd!=$qtg_pwd) ) $error=$L['E_access_denied'];
    if ( ($usr==$qtg_user_2) && ($pwd!=$qtg_pwd_2) ) $error=$L['E_access_denied'];
  }

  // execute
  if ( empty($error) )
  {
  $_SESSION['qtgAuth'] = 'yes';
  $_SESSION['pagedialog'] = 'l|'.$L['Welcome'].' '.$usr;
  $oHtml->Redirect('qtg_adm.php');
  }
}

// --------
// SUBMITTED for log-out
// --------

if ( isset($_GET['a']) ) {
if ( $_GET['a']=='out' ) {
  session_destroy();
  require_once 'qtg_init.php';
  $_SESSION['qtgAuth']='N';
  $oHtml->Redirect('qtg_index.php');
}}

// --------
// HTML
// --------

$oHtml->scripts[] = '<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.usr.value.length==0 || theForm.pwd.value.length==0) { alert(qtHtmldecode(\''.$L['E_mandatory'].'\')); return false; }
  return null;
}
//-->
</script>
';

include 'qtg_p_header.php';

echo '<h1>',$L['Login'],'</h1>
<div class="login">
<form method="post" action="',Href('qtg_adm_login.php'),'" onsubmit="return ValidateForm(this)">
<p class="login"><label for="usr">',$L['Username'],'</label> <input type="text" id="usr" name="usr" size="20" maxlength="24" value="',$usr,'"/></p>
<p class="login"><label for="pwd">',$L['Password'],'</label> <input type="password" id="pwd" name="pwd" size="20" maxlength="24"/></p>
<p class="login">',( !empty($error) ? '<span class="error">'.$error.'</span> ' : ''),'<input type="submit" name="ok" value="',$L['Login'],'"/></p>
</form>
</div>
<p>&nbsp;</p>',$qtg_back,'
';

$strFooterAddScript = '<script type="text/javascript">
<!--
document.getElementById("usr").focus();
if ( document.getElementById("usr").value.length>1 ) { document.getElementById("pwd").focus(); }
-->
</script>
';

include 'qtg_p_footer.php';