<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license.  If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTalk Guestbook
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2009-2012 The PHP Group
* @version    3.0 build:20120924
*/

session_start();
require_once 'qtg_init.php';
if ( !isset($_SESSION['qtgAuth']) || $_SESSION['qtgAuth']!='yes' ) HtmlRedirect('qtg_adm_login.php'); // CHECK LOGIN

include GetLang().'qtg_adm.php';
$qtg_skin='bin/css';

$pg_name=$L['Multiple_edits'];
$pg_url='qtg_adm_medit.php';

$a = 'hide';
if ( isset($_GET['a']) ) $a = strip_tags($_GET['a']);
if ( isset($_POST['a']) ) $a = strip_tags($_POST['a']);
if ( $a!='export' && $a!='hide' && $a!='unhide' && $a!='delete' ) $a='hide';

$intYear = (int)date('Y'); if ( intval(date('n'))<2 ) $intYear--; // year filter
$intMonth = 0; // all months

// --------
// SUBMITTED
// --------

if (isset($_POST['ok']))
{
  // Check form value

  $intYear = (int)$_POST['y'];
  $intMonth = (int)$_POST['m'];
  $strIp = strip_tags(trim($_POST['ip']));

  // Count impacted rows

  $str = strval($intYear); if ( $intMonth>0 ) $str = strval($intYear*100+$intMonth);

  switch($oDB->type)
  {
  case 'mysql4':
  case 'mysql': $strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
  case 'mssql':
  case 'sqlsrv':$strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
  case 'pg':    $strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
  case 'ibase': $strWhere = 'SUBSTRING(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
  case 'sqlite':$strWhere = 'SUBSTR(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
  case 'db2':   $strWhere = 'SUBSTR(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
  case 'oci':   $strWhere = 'SUBSTR(issuedate,1,'.strlen($str).')="'.$str.'"'; break;
  case 'file':  $strWhere = ''; break;
  default: die('Unknown db type '.$oDB->type);
  }
  if ( is_a($oDB,'cDT') )
  {
    if ( !empty($strIp) ) $strWhere .= $strIp;
    if ( $a=='hide' ) $strWhere .= '-y';
    if ( $a=='unhide' ) $strWhere .= '-n';
    $intCount = $oDB->FilesCount($strWhere,0,$str,$str,false);
  }
  else
  {
    if ( !empty($strIp) ) $strWhere .= ' AND ip="'.$strIp.'"';
    if ( $a=='hide' ) $strWhere .= ' AND visible="Y"';
    if ( $a=='unhide' ) $strWhere .= ' AND visible="N"';
    $oDB->Query( 'SELECT count(id) as countid FROM '.TABMESSAGE.' WHERE id>=0 AND '.$strWhere );
    $row = $oDB->Getrow();
    $intCount = intval($row['countid']);
  }

  // Execute

  if ( $intCount>0 )
  {
    include 'qtg_p_header.php';
    echo '<a id="exiturl" href="qtg_adm_medit_exe.php?y=',$intYear,'&amp;m=',$intMonth,'&amp;ip=',$strIp,'&amp;a=',$a,'&amp;n=',$intCount,'">Execute action ',$a,'...</a>';
    echo '
    <script type="text/javascript">
    <!--
    setTimeout(\'window.location=document.getElementById("exiturl").href\',0);
    -->
    </script>
    ';
    include 'qtg_p_footer.php';
    exit;
  }
  else
  {
    $strInfo = $L['E_no_selection'];
    if ( $a=='unhide' ) $strInfo = '[0 hidden message]... '.$L['E_no_selection'];
  }
}

// --------
// HTML START
// --------

include 'qtg_adm_p_header.php';
include 'qtg_adm_menu.php';

// first year
$firstyear = 0;
if ( is_a($oDB,'cDT') )
{
  $count = $oDB->FilesCount('',0,(string)date('Ym'),'0',true);
  $firstyear = (int)substr($oDB->firstfile,0,4);
}
else
{
  $oDB->Query( 'SELECT MIN(issuedate) as firstdate FROM '.TABMESSAGE.' WHERE id>=0 AND issuedate>="2000"' );
  if ($row = $oDB->Getrow()) $firstyear = (int)substr($row['firstdate'],0,4);
}
if ( empty($firstyear) ) $firstyear=date('Y');

$arrYears = array();
for ($i=$firstyear;$i<=date('Y');$i++) $arrYears[$i]=$i;

if ( isset($_GET['y']) && in_array((int)$_GET['y'],$arrYears) ) $intYear = (int)$_GET['y'];
if ( isset($_GET['m']) && ( (int)$_GET['m']>=0 && (int)$_GET['m']<=12 ) ) $intMonth = (int)$_GET['m'];

echo '<div class="inputbox">
<form method="post" action="',Href('qtg_adm_medit.php'),'">
<table class="hidden"><tr>
<td class="hidden" style="width:100px;border-right:solid 1px #aaaaaa">
<input type="radio" name="a" value="hide" id="a_hide"',($a=='hide' ? QCHE : ''),'/><label for="a_hide">',$L['Hide'],'</label><br/>
<input type="radio" name="a" value="unhide" id="a_unhide"',($a=='unhide' ? QCHE : ''),'/><label for="a_unhide">',$L['Unhide'],'</label><br/>
<input type="radio" name="a" value="delete" id="a_delete"',($a=='delete' ? QCHE : ''),'/><label for="a_delete">',$L['Delete'],'</label><br/>
<input type="radio" name="a" value="export" id="a_export"',($a=='export' ? QCHE : ''),'/><label for="a_export">',$L['Export'],'</label><br/>
</td>
<td class="hidden">
<p class="inputbox">',$L['Messages_posted_in'],'&nbsp;
<select name="y">',QTasTag($arrYears,$intYear),'</select>
<br/><br/>',$L['Month'],'&nbsp;<select name="m"><option value="0">',$L['All'],'</option>',QTasTag($L['dateMMM'],$intMonth),'</select>
<br/><br/>',$L['From_IP'],'&nbsp;<input type="text" name="ip" size="16" maxlength="24"/>
<br/><span class="small">',$L['HFrom_IP'],'</span>
</p>
</td>
</tr>
</table>
<br/>
<p class="inputbox"><input type="submit" name="ok" value="',$L['Next'],' &gt;"/></p>
</form>
</div>
';

// --------
// HTML END
// --------

include 'qtg_adm_p_footer.php';